# adapted from http://www.iamcal.com/publish/articles/php/processing_html_part_2/
# and from http://feedparser.org/tests/wellformed/sanitize/
# by Aaron Swartz, 2006, public domain

import unittest, new
from planet import BeautifulSoup

class SanitizeTest(unittest.TestCase): pass

# each call to HTML adds a test case to SanitizeTest
testcases = 0
def HTML(a, b):
  global testcases
  testcases += 1
  func = lambda self: \
    self.assertEqual(str(BeautifulSoup(a,convertEntities="html")), b)
  method = new.instancemethod(func, None, SanitizeTest)
  setattr(SanitizeTest, "test_%d" % testcases, method)

## basics
HTML("","")
HTML("hello","hello")

## balancing tags
HTML("<b>hello","<b>hello</b>")
HTML("hello<b>","hello<b></b>")
HTML("hello</b>","hello")
HTML("hello<b/>","hello<b></b>")
HTML("<b><b><b>hello","<b></b><b></b><b>hello</b>")
HTML("</b><b>","<b></b>")

## trailing slashes
HTML('<img>','<img />')
HTML('<img/>','<img />')
HTML('<b/></b>','<b></b>')

## balancing angle brakets
HTML('<img src="foo"','&lt;img src="foo"')
HTML('b>','b&gt;')
HTML('<img src="foo"/','&lt;img src="foo"/')
HTML('>','&gt;')
HTML('foo<b','foo&lt;b')
HTML('b>foo','b&gt;foo')
HTML('><b','&gt;&lt;b')
HTML('b><','b&gt;&lt;')
HTML('><b>','&gt;<b></b>')

## attributes
HTML('<img src=foo>','<img src="foo" />')
HTML('<img src=test test>','<img src="test" test="test" />')

## auto closers
HTML('<img src="a">', '<img src="a" />')
HTML('<img src="a">foo</img>', '<img src="a" />foo')
HTML('</img>', '')

# valid entity references
HTML("&nbsp;"," ");
HTML("&#160;"," ");
HTML("&#xa0;"," ");
HTML("&#xA0;"," ");

# unescaped ampersands
HTML("AT&T","AT&amp;T");
HTML("http://example.org?a=1&b=2","http://example.org?a=1&amp;b=2");

# quote characters
HTML('<a title="&#34;">quote</a>','<a title="&#34;">quote</a>')
HTML('<a title="&#39;">quote</a>','<a title="&#39;">quote</a>')
